require '_h2ph_pre.ph';

unless(defined(&_ASM_IA64_HARDIRQ_H)) {
    eval 'sub _ASM_IA64_HARDIRQ_H () {1;}' unless defined(&_ASM_IA64_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'linux/irq.ph';
    require 'asm/processor.ph';
    eval 'sub softirq_pending {
        local($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> &softirq_pending));
    }' unless defined(&softirq_pending);
    eval 'sub ksoftirqd_task {
        local($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> &ksoftirqd));
    }' unless defined(&ksoftirqd_task);
    eval 'sub irq_count {
        local($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> ($irq_stat->{f}->{irq_count})));
    }' unless defined(&irq_count);
    eval 'sub bh_count {
        local($cpu) = @_;
	    eval q(( &cpu_data($cpu)-> ($irq_stat->{f}->{bh_count})));
    }' unless defined(&bh_count);
    eval 'sub syscall_count {
        local($cpu) = @_;
	    eval q();
    }' unless defined(&syscall_count);
    eval 'sub nmi_count {
        local($cpu) = @_;
	    eval q(0);
    }' unless defined(&nmi_count);
    eval 'sub local_softirq_pending () {
        eval q(( ($local_cpu_data->{softirq_pending})));
    }' unless defined(&local_softirq_pending);
    eval 'sub local_ksoftirqd_task () {
        eval q(( ($local_cpu_data->{ksoftirqd})));
    }' unless defined(&local_ksoftirqd_task);
    eval 'sub local_irq_count () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{irq_count})));
    }' unless defined(&local_irq_count);
    eval 'sub local_bh_count () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{bh_count})));
    }' unless defined(&local_bh_count);
    eval 'sub local_syscall_count () {
        eval q();
    }' unless defined(&local_syscall_count);
    eval 'sub local_nmi_count () {
        eval q(0);
    }' unless defined(&local_nmi_count);
    eval 'sub in_interrupt () {
        eval q(( ($local_cpu_data->{irq_stat}->{irq_and_bh_counts}) != 0));
    }' unless defined(&in_interrupt);
    eval 'sub in_irq () {
        eval q(( ($local_cpu_data->{irq_stat}->{f}->{irq_count}) != 0));
    }' unless defined(&in_irq);
    eval 'sub hardirq_trylock {
        local($cpu) = @_;
	    eval q( &local_hardirq_trylock());
    }' unless defined(&hardirq_trylock);
    eval 'sub hardirq_endlock {
        local($cpu) = @_;
	    eval q( &local_hardirq_endlock());
    }' unless defined(&hardirq_endlock);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub local_hardirq_trylock () {
	    eval q(( &local_irq_count() == 0));
	}' unless defined(&local_hardirq_trylock);
	eval 'sub local_hardirq_endlock () {
	    eval q( &do { }  &while (0));
	}' unless defined(&local_hardirq_endlock);
	eval 'sub local_irq_enter {
	    local($irq) = @_;
    	    eval q(( &local_irq_count()++));
	}' unless defined(&local_irq_enter);
	eval 'sub local_irq_exit {
	    local($irq) = @_;
    	    eval q(( &local_irq_count()--));
	}' unless defined(&local_irq_exit);
	eval 'sub synchronize_irq () {
	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    } else {
	require 'asm/atomic.ph';
	require 'asm/smp.ph';
	eval 'sub local_hardirq_endlock () {
	    eval q( &do { }  &while (0));
	}' unless defined(&local_hardirq_endlock);
    }
}
1;
